import { Module } from '@nestjs/common';
import { DatabaseModule } from '../database/database.module';
import { UploadModule } from '../upload/upload.module';
import { clientProviders } from './oauth2-client.providers';
import { OAuth2ClientService } from './oauth2-client.service';

@Module({
  imports: [DatabaseModule, UploadModule],
  providers: [...clientProviders, OAuth2ClientService],
  exports: [OAuth2ClientService],
})
export class OAuth2ClientModule {}
