import { Module } from '@nestjs/common';
import { ConfigurationModule } from '../config/config.module';

import { AuditModule } from './audit/audit.module';
import { DatabaseModule } from './database/database.module';
import { DocumentModule } from './document/document.module';
import { EmailModule } from './email/email.module';
import { OAuth2ClientModule } from './oauth2-client/oauth2-client.module';
import { OAuth2TokenModule } from './oauth2-token/oauth2-token.module';
import { PrivilegeModule } from './privilege/privilege.module';
import { UploadModule } from './upload/upload.module';
import { UserModule } from './user/user.module';

@Module({
  imports: [
    ConfigurationModule,
    DatabaseModule,
    EmailModule,
    OAuth2ClientModule,
    OAuth2TokenModule,
    PrivilegeModule,
    UploadModule,
    UserModule,
    DocumentModule,
    AuditModule,
  ],
  exports: [
    DatabaseModule,
    EmailModule,
    OAuth2ClientModule,
    OAuth2TokenModule,
    PrivilegeModule,
    UploadModule,
    UserModule,
    DocumentModule,
    AuditModule,
  ],
})
export class ObjectsModule {}
