import { Module } from '@nestjs/common';
import { ConfigurationModule } from '../config/config.module';
import { JWTModule } from '../jwt/jwt.module';
import { ObjectsModule } from '../objects/objects.module';

import { LoginModule } from './login/login.module';
import { OAuth2RouterModule } from './oauth2-router/oauth2-router.module';
import { RegisterModule } from './register/register.module';
import { SettingsModule } from './settings/settings.module';
import { TwoFactorModule } from './two-factor/two-factor.module';

@Module({
  imports: [
    ConfigurationModule,
    JWTModule,

    ObjectsModule,

    LoginModule,
    OAuth2RouterModule,
    RegisterModule,
    SettingsModule,
    TwoFactorModule,
  ],
  providers: [],
  exports: [],
})
export class StaticFrontEndModule {}
